// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//! @todo use defaults button?
//! @todo EC logo & link to website
//! @todo about button?
//! @todo handle no data

var gDefaultLocations = new Object();

// --------------------------------------------------------------------------------
//! Called by HTML body element's onload event when the widget is ready to start.
// --------------------------------------------------------------------------------

function load()
{
	gDefaultLocations["WDU"] = "West Dulwich";
	gDefaultLocations["HNH"] = "Herne Hill";
	
    setupParts();
	loadPreferences();
	refreshTrainInfo();
	startRefreshTimer();
}

// --------------------------------------------------------------------------------
//! Called when the widget has been removed from the Dashboard
// --------------------------------------------------------------------------------

function remove()
{
	stopRefreshTimer();

    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

// --------------------------------------------------------------------------------
// Called when the widget has been hidden.
// --------------------------------------------------------------------------------

function hide()
{
	stopRefreshTimer();
}

// --------------------------------------------------------------------------------
// Called when the widget has been shown.
// --------------------------------------------------------------------------------

function show()
{
	startRefreshTimer();
}

// --------------------------------------------------------------------------------
// Called when the widget has been synchronized with .Mac
// --------------------------------------------------------------------------------

function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

// --------------------------------------------------------------------------------
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
// --------------------------------------------------------------------------------

function showBack(event)
{
	stopRefreshTimer();
	updateFieldsFromPreferences();
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

// --------------------------------------------------------------------------------
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
// --------------------------------------------------------------------------------

function showFront(event)
{
	updatePreferencesFromFields();
	savePreferences();
	refreshTrainInfo();
	startRefreshTimer();
	
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

// --------------------------------------------------------------------------------
//!
// --------------------------------------------------------------------------------

function trainInfoReceived(pythonOutput)
{
	if( pythonOutput.outputString )
	{
		var raw = pythonOutput.outputString;
		var data = raw.split("\t");
		
		var items = [];
		for (i = 0; i< data.length; i += 6) 
		{
			var item = new Object();
			item["destination"] = data[i];
			item["platform"] = data[i + 1];
			item["time"] = data[i + 2];
			item["expected"] = data[i + 3];
			item["operator"] = data[i + 4];
			items.push(item);
		}

		updateDisplay(2, items);
	}
	
}

// --------------------------------------------------------------------------------
//!
// --------------------------------------------------------------------------------

function getLocationName(location)
{
	var locations = gPreferences["locations"];
	return locations[location];
}

// --------------------------------------------------------------------------------
//!
// --------------------------------------------------------------------------------

function updateDisplay(lines, items)
{
	var filter = gPreferences["filter"];
	var platform = gPreferences["platform"];
	var title = getLocationName(gPreferences["location"]);

	document.getElementById('label').innerText = title;
	
	var done = 0;
	var line;
	for (var line = 1; line <= items.length; line++)
	{
		var item = items[line - 1];
		if (!filter || (platform == item["platform"]))
		{
			done++;
			var destField = document.getElementById('line' + done);
			var timeField = document.getElementById('time' + done);
			var expected = item["expected"];
			var time = item["time"];
			var timeColour = "black";
			
			if ((expected != "On time") && (expected != "Starts here"))
			{
				time = expected;
				timeColour = "red";
			}
				
			destField.innerText = item["destination"];
			timeField.innerText = time;
			timeField.style.setProperty("color", timeColour);
			
			if (done == lines)
				break;
		}
	}
	
	// clear out unused lines
	for (var line = done + 1; line <= lines; ++line)
	{
		document.getElementById('line' + line).innerText = "";
		document.getElementById('time' + line).innerText = "";
	}
	
}


// --------------------------------------------------------------------------------
//!
// --------------------------------------------------------------------------------

function refreshTrainInfo()
{
	var command = "/usr/bin/python \"train widget\".py " + gPreferences["location"];
	widget.system(command, trainInfoReceived );
}

// --------------------------------------------------------------------------------
//!
// --------------------------------------------------------------------------------

function updateFieldsFromPreferences()
{
	updateCheckedFromPreference("filter");
	updateFieldFromPreference("platform");
	updateFieldFromPreference("refresh");
	updatePopupFromPreference("location", "locations");
	updatePopupStatus();
	updateFilterStatus();
}


// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function updatePreferencesFromFields()
{
	changeName();
	changeCode();
	updatePreferenceFromChecked("filter");
	updatePreferenceFromField("platform");
	updatePreferenceFromField("refresh");
	updatePreferenceFromPopup("location", "locations");
}

// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function loadPreferences()
{
	gPreferences["filter"] = loadPreference("filter", false);
	gPreferences["platform"] = loadPreference("platform", 0);
	gPreferences["refresh"] = loadPreference("refresh", 10);
	gPreferences["location"] = loadPreference("location", "WDU");
	gPreferences["locations"] = loadDictionaryPreference("locations", gDefaultLocations);
}


// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function savePreferences()
{
	savePreference("filter");
	savePreference("platform");
	savePreference("refresh");
	savePreference("location");
	saveDictionaryPreference("locations");
}


// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------


function changeLocation(event)
{
	updatePopupStatus();
}

// --------------------------------------------------------------------------------
//! Update the state of the popup and its associated fields.
// --------------------------------------------------------------------------------

function updatePopupStatus()
{
	var popup = document.getElementById("location");
	var selection = popup.options.selectedIndex;
	var nameField = document.getElementById("name");
	var codeField = document.getElementById("code");
	var minusButton = document.getElementById("minus");
	
	if (selection > -1)
	{
		nameField.value = popup.options[selection].text;
		codeField.value = popup.options[selection].value;
		nameField.disabled = false;
		codeField.disabled = false;
		minusButton.disabled = false;
	}
	else
	{
		nameField.value = "";
		codeField.value = "";
		nameField.disabled = true;
		codeField.disabled = true;
		minusButton.disabled = true;
	}
}

// --------------------------------------------------------------------------------
//! Update the state of the platform field, based on the filter checkbox setting.
// --------------------------------------------------------------------------------

function updateFilterStatus()
{
	var filter = document.getElementById("filter");
	var platform = document.getElementById("platform");
	var checked = filter.checked;
	platform.disabled = !checked;
}

// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function changeName(event)
{
	var popup = document.getElementById("location");
	var selection = popup.options.selectedIndex;
	popup.options[selection].text = document.getElementById("name").value;
	popup.options[selection].value = document.getElementById("code").value;
}

// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function changeCode(event)
{
	var popup = document.getElementById("location");
	var selection = popup.options.selectedIndex;
	popup.options[selection].value = document.getElementById("code").value;
}

// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function addLocation(event)
{
	var popup = document.getElementById("location");
	var index = popup.options.length;
	var option = new Option("UNT");
	option.text = "Untitled";
	popup.options[index] = option;
	popup.options.selectedIndex = index;
	updatePopupStatus();
}

// --------------------------------------------------------------------------------
//! 
// --------------------------------------------------------------------------------

function removeLocation(event)
{
	var popup = document.getElementById("location");
	var selection = popup.options.selectedIndex;
	if (selection > -1)
	{
		var length = popup.options.length;
		
		if (length != selection)
			popup.options[selection] = popup.options[length - 1];
		popup.options.length = length - 1;
		updatePopupStatus();
	}
}

// --------------------------------------------------------------------------------
//! Start the refresh timer running, using the refresh setting.
// --------------------------------------------------------------------------------

function startRefreshTimer()
{
	setInterval(refreshTrainInfo, gPreferences["refresh"] * 60000);
}

// --------------------------------------------------------------------------------
//! Stop the refresh timer from running.
// --------------------------------------------------------------------------------

function stopRefreshTimer()
{
	clearInterval(refreshTrainInfo);
}


function filterKeys(event)
{
	if (event.which == 13)
		showFront();
		
}


// --------------------------------------------------------------------------------
//! Global Setup Code 
// --------------------------------------------------------------------------------

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}



function copyrightClicked(event)
{
   widget.openURL("http://www.elegantchaos.com/widgets/liveupdate");
}
