#! /usr/bin/python

import sys, urllib, re, datetime, time
import sgmllib
from xml.dom import minidom

BASE_URL = "http://www.livedepartureboards.co.uk/ldb/sumdep.aspx?T="


class MyParser(sgmllib.SGMLParser):

	def parse(self, s):
		self.feed(s)
		self.close()

	def __init__(self, verbose=0):
		sgmllib.SGMLParser.__init__(self, verbose)
		self.hyperlinks = []
		self.rows = []
		self.row = None
		self.cell = None
		
	def start_a(self, attributes):
		"Process a hyperlink and its 'attributes'."

		for name, value in attributes:
			if name == "href":
				self.hyperlinks.append(value)

	def start_tr(self, attributes):
		for name, value in attributes:
			if (name == "class") and ((value == "row1") or (value == "row2")):
				self.row = []
				break

	def end_tr(self):
		if self.row is not None:
			self.rows = self.rows + self.row
			self.row = None

	def start_td(self, attributes):
		self.cell = ""

	def end_td(self):
		if self.row is not None:
			self.row = self.row + [self.cell]
			self.cell = None
		
	def handle_data(self, data):
		if self.cell is not None:
			if self.cell is not "":
				self.cell = self.cell + " " + data
			else:
				self.cell = self.cell + data
			
	def get_hyperlinks(self):
		return self.hyperlinks

	def get_rows(self):
		return self.rows

def GetDisplay(station):
	url = BASE_URL + station
	f = urllib.urlopen(url)
	content = f.read()
	f.close()
	
	parser = MyParser()
	parser.parse(content)
	
	print "\t".join(parser.get_rows())

# get variables

def Main():
	if len(sys.argv) > 1:
		station = sys.argv[1].upper()
	else:
		station = "WDU"
	
	GetDisplay(station)
	
	
Main()